unit PdoxTst;
interface
uses Windows, SysUtils, Classes, Forms, Controls, StdCtrls, Buttons, Paradox;
type TPdox = class(TForm)
    Edit1: TEdit;
    NextBtn: TButton;
    Memo1: TMemo;
    CloseBtn: TButton;
    ClearBtn: TButton;
    FindBtn: TButton;
    Edit2: TEdit;
    procedure BtnClick(Sender: TObject);
  private
  public
  end;

VAR Pdox: TPdox;
implementation  {$R *.DFM}

{---- Test Direct File I/O for Paradox tables --------------------------------}
procedure TPdox.BtnClick(Sender: TObject);
  const  Pdx: TParadox =nil;
  var  i,j,fnd: Integer;  v: Int64;  S: String;
begin
  If Pdx=nil Then begin
    Pdx := TParadox.Create(Self);  Pdx.Name := 'MyDB';   end;
  If not Pdx.Active Then begin  Pdx.TableName := Edit1.Text;  Pdx.Open;  end;
  If Sender=CloseBtn Then begin  Pdx.Close;  Exit;  end;
  If Sender=ClearBtn Then begin  Memo1.Clear;  Exit;  end;
  If Sender=FindBtn Then begin   S := Edit2.Text;  fnd := 0;
    If Pdx.KeyFields=0 Then begin {No Primary Key: Use Locate}
      If Pdx.Locate([0],[S]) Then fnd := 1;   end
    Else begin  j := Pos(';',S); {Up to 2 Key Flds using ";"}
      If j=0 Then begin  If Pdx.FindKey([S]) Then fnd := 2;  end {1 Key Fld}
      Else If Pdx.FindKey([Copy(S,1,j-1),Copy(S,j+1,99)]) Then
        fnd := 3; {2 Key Flds}   end{Else};
    If fnd=0 Then begin
      Memo1.Lines.Add('<<Not Found>>');  Exit;   end;   end{If =FindBtn};
  If Pdx.EOF Then begin  Memo1.Lines.Add('<<EOF>>');  Pdx.Close;  Exit;   end;
  For i := 0 to Pdx.FieldCount-1 Do begin {Dump the record}
    S := Pdx.FieldName(i)+': '+Pdx.Field(i);  v := Pdx.FieldAsInteger(i);
    If v>0 Then S := S+' (AsInt='+IntToStr(Pdx.FieldAsInteger(i))+')';
    For j := 1 to Length(S) Do {Memos don't like ctrl chars}
      If S[j]<' ' Then S[j] := '.';
    Memo1.Lines.Add(S);  end{For i};
  Memo1.Lines.Add('- - - - - -');  Pdx.Next;
  end{PdoxBtnClick};

END.

